<?php
/*
ipn.php - example code used for the tutorial:

PayPal IPN with PHP
How To Implement an Instant Payment Notification listener script in PHP
http://www.micahcarrick.com/paypal-ipn-with-php.html

(c) 2011 - Micah Carrick
*/

// tell PHP to log errors to ipn_errors.log in this directory
ini_set('log_errors', true);
ini_set('error_log', dirname(__FILE__).'/ipn_errors.log');

// intantiate the IPN listener
include('../includes/inc.config.php');
include('lib.functions.php');
include('ipnlistener.php');
$listener = new IpnListener();

if (isset($_GET['type']) && ($_GET['type'] == 'pp')){

		$custom = mysql_real_escape_string($_POST['custom']);
		$prepare = explode('|',$custom);
		$agent_id = $prepare[0];
        $level_id = $prepare[1];
		$period = $prepare[2];
		$currency = $prepare[3];
		$exist = $prepare[4];
// tell the IPN listener to use the PayPal test sandbox
$listener->use_sandbox = settings('pp_sandbox');

// try to process the IPN POST
try {
    $listener->requirePostMethod();
    $verified = $listener->processIpn();
} catch (Exception $e) {
    error_log($e->getMessage());
    exit(0);
}
//if ($verified) {

    $errmsg = '';   // stores errors from fraud checks
    
    // 1. Make sure the payment status is "Completed" 
    if ($_POST['payment_status'] != 'Completed') { 
        // simply ignore any IPN that is not completed
        exit(0); 
    }

    // 2. Make sure seller email matches your primary account email.
    if ($_POST['receiver_email'] != settings('admin_pp')) {
        $errmsg .= "'receiver_email' does not match: ";
        $errmsg .= $_POST['receiver_email']."\n";
    }
    
    
    // 4. Make sure the currency code matches
    if ($_POST['mc_currency'] != $currency) {
        $errmsg .= "'mc_currency' does not match: ";
        $errmsg .= $_POST['mc_currency']."\n";
    }

    // 5. Ensure the transaction is not a duplicate.

    $txn_id = mysql_real_escape_string($_POST['txn_id']);
    $sql = "SELECT COUNT(*) FROM invoices WHERE txn = '$txn_id'";
    $r = mysql_query($sql);
    
    if (!$r) {
        error_log(mysql_error());
        exit(0);
    }
    
    $exists = mysql_result($r, 0);
    mysql_free_result($r);
    
    if ($exists) {
        $errmsg .= "'txn_id' has already been processed: ".$_POST['txn_id']."\n";
    }
    
    if (!empty($errmsg)) {
    
        // manually investigate errors from the fraud checking
        $body = "IPN failed fraud checks: \n$errmsg\n\n";
        $body .= $listener->getTextReport();
        mail(settings('admin_email'), 'IPN Fraud Warning', $body);
        
    } else {
    $period_time = ($period > 1 ? '+'.$period.' months' : '+'.$period.' month');
    $renew = strtotime($period_time, time());
        // add this order to a table of completed orders
        $payer_email = mysql_real_escape_string($_POST['payer_email']);
        $mc_gross = mysql_real_escape_string($_POST['mc_gross']);
		if($exist != 0){
		$sql = mysql_query("update invoices set `txn` = '$txn_id', `price` = '$mc_gross', `currency` = '$currency', `period` = '$period', `level_id` = '$level_id', `indate` = '".time()."', `renew` = '$renew', `status` = '1' where `agent_id` = '$agent_id'");       
		$client = mysql_query("update useraccounts set `status` = '1' where id = '$agent_id'");
        }else{
		$sql = mysql_query("INSERT INTO invoices(`txn`, `agent_id`, `price`, `currency`, `period`, `level_id`, `indate`, `renew`, `status`) 
		                     VALUES ('$txn_id', '$agent_id', '$mc_gross', '$currency', '$period', '$level_id', '".time()."', '$renew', '1')");	
        $client = mysql_query("update useraccounts set `status` = '1' where id = '$agent_id'");							 
		}
        if (!$sql) {
            error_log(mysql_error());
            exit(0);
        }
        
        // send user an email
        $to = filter_var(agent_data($agent_id,'email'), FILTER_SANITIZE_EMAIL);
        $subject = "Subscription Complete";
        mail($to, 'Thank you for your order', 'Your subscription is complete,you can now access your account on '.settings('site_title').' using this link: <a href="'.ROOT_URL.'/agent">'.ROOT_URL.'/agent</a>. You can find our Subscriptions Plans here: <a href="'.ROOT_URL.'/agent-level">'.ROOT_URL.'/agent-level</a> if you need upgrade your account. Best Regards, '.settings('site_title').'');
   		
		$body = "New payment recived via PayPal from ".agent_data($agent_id,'username').", ".agent_data($agent_id,'email')."\n\n";
        //$body .= $listener->getTextReport();
        mail(settings('admin_email'), 'New payment recived!', $body);

   }
/*    
} else {
    // manually investigate the invalid IPN
    mail(settings('admin_email'), 'Invalid IPN', $listener->getTextReport());
}
*/

}else if (isset($_GET['type']) && ($_GET['type'] == 'mb')){
		$agent_id = $_POST['agent_id'];
        $level_id = $_POST['level_id'];
		$period = $_POST['period'];
		$currency = $_POST['currency'];
		$exist = $_POST['exist'];
// Validate the Moneybookers signature
$concatFields = $_POST['merchant_id']
    .$_POST['transaction_id']
    .strtoupper(md5(settings('mb_secret')))
    .$_POST['mb_amount']
    .$_POST['mb_currency']
    .$_POST['status'];

$MBEmail = settings('admin_mb');

// Ensure the signature is valid, the status code == 2,
// and that the money is going to you
if (strtoupper(md5($concatFields)) == $_POST['md5sig']
    && $_POST['status'] == 2
    && $_POST['pay_to_email'] == $MBEmail)
{
    $period_time = ($period > 1 ? '+'.$period.' months' : '+'.$period.' month');
    $renew = strtotime($period_time, time());
    // Valid transaction
		if($exist != 0){
		$sql = mysql_query("update invoices set `txn` = '".$_POST['transaction_id']."', `price` = '".$_POST['mb_amount']."', `currency` = '$currency', `period` = '$period', `level_id` = '$level_id', `indate` = '".time()."', `renew` = '$renew', `status` = '1' where `agent_id` = '$agent_id'");       
		$client = mysql_query("update useraccounts set `status` = '1' where id = '$agent_id'");
        }else{
		$sql = mysql_query("INSERT INTO invoices(`txn`, `agent_id`, `price`, `currency`, `period`, `level_id`, `indate`, `renew`, `status`) 
		                     VALUES ('".$_POST['transaction_id']."', '$agent_id', '".$_POST['mb_amount']."', '$currency', '$period', '$level_id', '".time()."', '$renew', '1')");	
        $client = mysql_query("update useraccounts set `status` = '1' where id = '$agent_id'");							 
		}
							 
		$client = mysql_query("update customers set `status` = '1' where id = '$agent_id'");
		
        // send user an email
        $to = filter_var(agent_data($agent_id,'email'), FILTER_SANITIZE_EMAIL);
        $subject = "Subscription Complete";
        mail($to, 'Thank you for your order', 'Your subscription is complete,you can now access your account on '.settings('site_title').' using this link: <a href="'.ROOT_URL.'/agent">'.ROOT_URL.'/agent</a>. You can find our Subscriptions Plans here: <a href="'.ROOT_URL.'/agent-level">'.ROOT_URL.'/agent-level</a> if you need upgrade your account. Best Regards, '.settings('site_title').'');
   		
		$body = "New payment recived via MoneBookers from ".agent_data($agent_id,'username').", ".agent_data($agent_id,'email')."\n\n";
        //$body .= $listener->getTextReport();
        mail(settings('admin_email'), 'New payment recived!', $body);
}
else
{
    // Invalid transaction. Bail out
		 $body = "MoneyBookers IPN Tranzaction failed: Tranzaction Id: ".$_POST['transaction_id']."";
        //$body .= $listener->getTextReport();
        mail(settings('admin_email'), 'MoneyBookers IPN Tranzaction Failed', $body);
    exit;
}
}
?>